"""
Internal utility functions.

Except for logging, modules in this package should not depend on any other part of the repo.
"""

from .coro_management import run_coros
from .file_handling import filehash_update, update_hasher_for_source
from .helpers import get_cwd_editable_install
from .lazy_module import lazy_module
from .uv_script_parser import parse_uv_script_file

__all__ = [
    "filehash_update",
    "get_cwd_editable_install",
    "lazy_module",
    "parse_uv_script_file",
    "run_coros",
    "update_hasher_for_source",
]
